#!/usr/bin/env python

# Author                 Version      Date
# -----------------------------------------------
# Martin Still (SAAO)    1.0          08 Sep 2006

# saltfit...

# linear least square polynomial fit with sigma-clipping
# -----------------------------------------------------------
def poly(x,y,order,rej_lo,rej_hi,niter):

# x = list of x data
# y = list of y data
# order = polynomial order
# rej_lo = lower rejection threshold (units=sigma)
# rej_hi = upper rejection threshold (units=sugma)
# niter = number of sigma-clipping iterations

    import saltprint,math
    import Tkinter
    from pylab import polyfit, polyval

    npts = []
    iiter = 0
    iterstatus = 1

# sigma-clipping iterations

    while (iiter < niter and iterstatus > 0):
	iterstatus = 0
	tmpx = []
	tmpy = []
	npts.append(len(x))
	coeffs = polyfit(x,y,order)
	fit = polyval(coeffs,x)

# calculate sigma of fit

	sig = 0
	for ix in range(npts[iiter]):
	    sig = sig + (y[ix] - fit[ix])**2
	sig = math.sqrt(sig / (npts[iiter] - 1))

# point-by-point sigma-clipping test

	for ix in range(npts[iiter]):
	    if (y[ix] - fit[ix] < rej_hi * sig and
		fit[ix] - y[ix] < rej_lo * sig):
		tmpx.append(x[ix])
		tmpy.append(y[ix])
	    else:
		iterstatus = 1
	x = tmpx
	y = tmpy
	iiter += 1

# coeffs = best fit coefficients
# iiter = number of sigma clipping iteration before convergence

    return coeffs, iiter
